<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 20.100 registration form</title>
    <!-- Nhúng thư viện bootstrap 4-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container jumbotron">
        <div class="row">
            <div class="col-sm-12">
                <h4 class="text-center text-primary">Registration Form - Form đăng kí nhập cảnh</h4>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="row">
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>First Name <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-first-name" placeholder="Nhập first name">
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Passport <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-passport" placeholder="Nhập passport">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Last Name <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-last-name" placeholder="Nhập last name">
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Email</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-email" placeholder="Nhập email">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Birthday <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-birthday" placeholder="Nhập birthday">
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Country <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-country" placeholder="Nhập country">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Gender <span class = "text-danger">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                                <div class = "row">
                                    <div class = "col-sm-3">
                                        <input type="radio" name="select-gender" value="male">
                                        <label for="male-gender">Male</label>
                                    </div>
                                    <div class = "col-sm-4">
                                        <input type="radio" name="select-gender" value="female">
                                        <label for="female-gender">Female</label>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Region</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control bg-light" id="inp-region" placeholder="Nhập region">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-2">
                <label>Subject</label>
            </div>
            <div class="col-sm-10">
                <textarea class="form-control" id="inp-subject"></textarea>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12 text-right">
                <button class="btn btn-success" id="btn-send-data">Send</button>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gInpFirstName = $("#inp-first-name");
    var gInpLastName = $("#inp-last-name");
    var gInpCountry = $("#inp-country");
    var gInpEmail = $("#inp-email");
    var gInpBirthday = $("#inp-birthday");
    var gInpPassport = $("#inp-passport");
    var gInpRegion = $("#inp-region");
    var gInpSubject = $("#inp-subject");
    var gSelectGender = $("#select-gender");
    var gGenderSelected = "";
    var gIsDataCheck = false;


    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        $("#btn-send-data").on("click", onBtnSendData);
         /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý khi nhấn nút send data
    function onBtnSendData () {
       var vPersonObj = {
        firstname: "", 
        lastname: "", 
        birthday: 0,
        gender: "", 
        country: "",
        region: "", 
        passport: "", 
        email:"", 
        subject:"" 
       }

       //bước 1: thu thập dữ liệu 
            getData(vPersonObj);
            console.log(vPersonObj);
       //bước 2: kiểm tra dữ liệu 
            var vCheck = validateData(vPersonObj);
            if(vCheck){
                 //buớc 3: hiển thị dữ liệu 
                 showData(vPersonObj);
            }
      

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //hàm thu thập dữ liệu 
    function getData(paramPersonObj){
        paramPersonObj.firstname = gInpFirstName.val().trim();
        paramPersonObj.lastname = gInpLastName.val().trim();
        paramPersonObj.birthday = gInpBirthday.val().trim();
        paramPersonObj.gender  = $('input[name="select-gender"]:checked').val()
        paramPersonObj.country = gInpCountry.val();
        paramPersonObj.region = gInpRegion.val().trim();
        paramPersonObj.passport = gInpPassport.val().trim();
        paramPersonObj.email = gInpEmail.val().trim();
        paramPersonObj.subject = gInpSubject.val().trim();  
    }

    //hàm kiểm tra dữ liệu 
    function validateData(paramPersonObj){
        if(paramPersonObj.firstname == ""){
            alert("Bạn cần nhập Firstname!!!");
            return false;
        }
        if(paramPersonObj.lastname == ""){
            alert("Bạn cần nhập Lastname!!!");
            return false;
        }
        if(paramPersonObj.birthday == ""){
            alert("Bạn cần nhập Birthday!!!");
            return false;
        }
        if(!isNumeric(paramPersonObj.birthday)){
            alert("Bạn cần nhập Birthday là số!!!");
            return false;
        }
        if(paramPersonObj.email == ""){
            alert("Bạn cần nhập Email!!!");
            return false;
        }
        if(!validateEmail(paramPersonObj.email)){
            alert("Email không hợp lệ!!!");
            return false;
        }
        var vGender = $('input[name="select-gender"]:checked').val()
        if(vGender == undefined){
            alert("Vui lòng chọn Gender!!!");
            return false;
        }
        if(paramPersonObj.subject == ""){
            alert("Bạn cần nhập Subject!!!");
            return false;
        }
        if(paramPersonObj.passport == ""){
            alert("Bạn cần nhập Passport!!!");
            return false;
        }   
        if(paramPersonObj.country == ""){
            alert("Bạn cần nhập Country!!!");
            return false;
        }
        if(paramPersonObj.region == ""){
            alert("Bạn cần nhập Region!!!");
            return false;
        }
        return true;
    }

    //hàm kiểm tra birthday
    function isNumeric(paramBirthday){
        var vRegex = /^\d{1,2}\/\d{1,2}\/\d{4}$/;
        return vRegex.test(paramBirthday);
    }

    //hàm kiểm tra email
    function validateEmail(paramEmail){
        var  vEmailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return vEmailRegex.test(paramEmail);
    }

    //hàm show dữ liệu
    function showData(paramPersonObj){
        console.log("Firstname: " + paramPersonObj.firstname);
        console.log("Lastname: " + paramPersonObj.lastname);
        console.log("Birthday: " + paramPersonObj.birthday);
        console.log("Gender: " + paramPersonObj.gender);
        console.log("Passport: " + paramPersonObj.passport);
        console.log("Email: " + paramPersonObj.email);        
        console.log("Country: " + paramPersonObj.country);
        console.log("Region: " + paramPersonObj.region);
        console.log("Subject: " + paramPersonObj.subject);
    }

 })
   
    
</script>
</html>